<?php

/***************************************************************
 *  Copyright notice
 *
 *  (c) 2013 GroupDocs Marketplace Team <marketplace@groupdocs.com>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
 *  free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 1 of the License, or
 *  (at your option) any later version.
 *
 *  The GNU General Public License can be found at
 *  http://www.gnu.org/copyleft/gpl.html.
 *
 *  This script is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  This copyright notice MUST APPEAR in all copies of the script!
 ***************************************************************/
/**
 * Pplugin 'GroupDocs.Annotation for .NET' for the 'groupdocsannotationdotnet' extension.
 *
 * @author	GroupDocs Marketplace Team <marketplace@groupdocs.com>
 */



require_once(PATH_tslib.'class.tslib_pibase.php');
class tx_groupdocs_annotation_for_net_pi1 extends tslib_pibase {
	var $prefixId = 'tx_groupdocs_annotation_for_net_pi1';
	var $scriptRelPath = 'pi1/class.tx_groupdocs_annotation_for_net_pi1.php';
	var $extKey = 'groupdocs_annotation_for_net';
	var $pi_checkCHash = TRUE;

    /**
     * Fonction d'initialisation
     *
     * @param	string		$content: The PlugIn content
     * @param	array		$conf: The PlugIn configuration
     * @return	The content that is displayed on the website
     */

	function main($content,$conf)	{
		

		$this->conf=$conf;
		$this->pi_setPiVarDefaults();
		$this->pi_loadLL();
		$this->pi_initPIflexForm();
		if($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'server_url', 'sPARAMS')!='') {
			$this->conf['server_url'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'server_url', 'sPARAMS');
		}
        if($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'handlers', 'sPARAMS')!='') {
            $this->conf['handlers'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'handlers', 'sPARAMS');
        }
        if($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'file_path', 'sPARAMS')!='') {
            $this->conf['file_path'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'file_path', 'sPARAMS');
        }
        if($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'user_name', 'sPARAMS')!='') {
            $this->conf['user_name'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'user_name', 'sPARAMS');
        }
		if($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'width', 'sPARAMS')!='') {
			$this->conf['width'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'width', 'sPARAMS');  
		}
		if($this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'height', 'sPARAMS')!='') {
			$this->conf['height'] = $this->pi_getFFvalue($this->cObj->data['pi_flexform'], 'height', 'sPARAMS');  
		}



        $width = (int)$this->conf['width'];
        $height = (int)$this->conf['height'];

        if ($this->conf['handlers'] == 1) {
            $handler = "Handler";
            $use = true;
            $ajaxPath = $groupdocs_url . "/ajax.ashx/" . $this->conf['user_name'];
            $postData = "";
        } else {
            $handler = "";
            $use = false;
            $ajaxPath = $groupdocs_url . "/home/getId/";
            $postData = "un=" . $this->conf['user_name'];
        }
        // insert groupdocs
        if ($this->conf['server_url']) {

            if (substr($this->conf['server_url'], -1) == '/') {
                $groupdocs_url = substr_replace($this->conf['server_url'], "", -1);
            }
            $url = $groupdocs_url . "/document-viewer/GetScript" . $handler . "?name=libs/jquery-ui-1.10.3.min.js";
            $headers = get_headers($url, 1);
            if ($headers[0] == 'HTTP/1.1 200 OK') {
                $content = '';
                // standard embedding
                $txt = "<script src='" . $groupdocs_url . "/Scripts/jquery-1.10.2.min.js' type='text/javascript'></script>
                        <script src='" . $groupdocs_url . "/Scripts/jquery-ui-1.10.3.min.js' type='text/javascript'></script>
                        <script type='text/javascript' src='" . $groupdocs_url . "/document-viewer/GetScript" . $handler . "?name=libs/jquery-1.9.1.min.js'></script>
                        <script type='text/javascript' src='" . $groupdocs_url . "/document-viewer/GetScript" . $handler . "?name=libs/jquery-ui-1.10.3.min.js'></script>
                        <script type='text/javascript' src='" . $groupdocs_url . "/document-viewer/GetScript" . $handler . "?name=libs/knockout-3.0.0.js'></script>
                        <script type='text/javascript' src='" . $groupdocs_url . "/document-viewer/GetScript" . $handler . "?name=libs/turn.min.js'></script>"
                    . "<script type='text/javascript' src='" . $groupdocs_url . "/document-viewer/GetScript" . $handler . "?name=libs/modernizr.2.6.2.Transform2d.min.js'></script>"
                    . "<script type='text/javascript'>if (!window.Modernizr.csstransforms)   $.ajax({url: '" . $groupdocs_url . "/document-viewer/GetScript" . $handler . "?name=libs/turn.html4.min.js', "
                    . "dataType: 'script', type: 'GET', async: false});</script>"
                    . "<script type='text/javascript' src='" . $groupdocs_url . "/document-viewer/GetScript" . $handler . "?name=installableViewer.min.js'></script>"
                    . "<script type='text/javascript'>$.ui.groupdocsViewer.prototype.applicationPath = '" . $groupdocs_url . "/';</script>"
                    . "<script type='text/javascript'>$.ui.groupdocsViewer.prototype.useHttpHandlers = " . $use . ";</script>"
                    . "<script type='text/javascript' src='" . $groupdocs_url . "/document-viewer/GetScript" . $handler . "?name=GroupdocsViewer.all.min.js'></script>"
                    . "<link rel='stylesheet' type='text/css' href='" . $groupdocs_url . "/document-viewer/CSS/GetCss" . $handler . "?name=bootstrap.css' />"
                    . "<link rel='stylesheet' type='text/css' href='" . $groupdocs_url . "/document-viewer/CSS/GetCss" . $handler . "?name=GroupdocsViewer.all.min.css' />"
                    . "<link rel='stylesheet' type='text/css' href='" . $groupdocs_url . "/document-viewer/CSS/GetCss" . $handler . "?name=jquery-ui-1.10.3.dialog.min.css' />
                        <script type='text/javascript' src='" . $groupdocs_url . "/document-annotation/GetScript" . $handler . "?name=libs/jquery.signalR-1.1.2.min.js'></script>
                        <script type='text/javascript' src='" . $groupdocs_url . "/document-annotation/GetScript" . $handler . "?name=libs/jquery.tinyscrollbar.min.js'></script>
                        <script type='text/javascript' src='" . $groupdocs_url . "/document-annotation/GetScript" . $handler . "?name=GroupdocsAnnotation.all.min.js'></script>
                        <link rel='stylesheet' type='text/css' href='" . $groupdocs_url . "/document-annotation/CSS/GetCss" . $handler . "?name=Annotation.css' />
                        <link rel='stylesheet' type='text/css' href='" . $groupdocs_url . "/document-annotation/CSS/GetCss" . $handler . "?name=Toolbox.css' />
                        <script type='text/javascript' src='" . $groupdocs_url . "/signalr1_1_2/hubs'></script>
                        <script type='text/javascript'>
                                var userName = '" . $this->conf['user_name'] . "';
                                //Send ajax request to set entered user as collaborator for document
                                $.ajax({
                                    type: 'POST',
                                    url: '" . $ajaxPath . "',
                                    data: '" . $postData . "',
                                    cache: false,
                                    async: true,
                                    success: function (userInfo){
                                        var userId = '';
                                        if (typeof userInfo === 'object') {
                                            userId = userInfo[0];
                                        } else {
                                            userId = userInfo
                                        }
                                        //All settings for integrated Annotation
                                        var annotationWidget = $('#annotation-widget').groupdocsAnnotation({
                                            width: 600,
                                            height: 800,
                                            fileId: '" . $this->conf['file_path'] . "',
                                            docViewerId: 'annotation-widget-doc-viewer',
                                            quality: 90,
                                            enableRightClickMenu: false,
                                            showHeader: false,
                                            showZoom: true,
                                            showPaging: true,
                                            showPrint: false,
                                            showFileExplorer: true,
                                            showThumbnails: true,
                                            openThumbnails: false,
                                            zoomToFitWidth: false,
                                            zoomToFitHeight: false,
                                            initialZoom: 100,
                                            preloadPagesCount: 0,
                                            sideboarContainerSelector: 'div.comments_sidebar_wrapper',
                                            usePageNumberInUrlHash: false,
                                            textSelectionSynchronousCalculation: true,
                                            variableHeightPageSupport: true,
                                            useJavaScriptDocumentDescription: true,
                                            isRightPanelEnabled: true,
                                            createMarkup: true,
                                            use_pdf: 'true',
                                            _mode: 'annotatedDocument',
                                            selectionContainerSelector: \"[name='selection-content']\",
                                            graphicsContainerSelector: '.annotationsContainer',
                                            userName: userName,
                                            userId: userId,
                                            enabledTools: -1,
                                            enableSidePanel: true
                                        });
                                        var annotationsViewer = $(annotationWidget).groupdocsAnnotation('getViewer');
                                        var annotationsViewerVM = $(annotationsViewer).groupdocsAnnotationViewer('getViewModel');
                                        var commentModePanel = $(annotationWidget).find('div.embed_annotation_tools');
                                        commentModePanel.css('margin-right', 0);
                                        commentModePanel.draggable({
                                            scroll: false,
                                            handle: '.tools_dots',
                                            containment: 'body',
                                            appendTo: 'body'
                                        });
                                        $(annotationWidget).find('.tool_field').click(function () {
                                            var toolFields = $(annotationWidget).find('.tool_field');
                                            if (toolFields.hasClass('active')) {
                                                $(toolFields.removeClass('active'));
                                            };
                                            $(this).addClass('active');
                                        });
                                        $(annotationWidget).find('.header_tools_icon').hover(

                                            function () {
                                                $(this).find('.tooltip_on_hover').css('display', 'block');
                                            },

                                            function () {
                                                $(this).find('.tooltip_on_hover').css('display', 'none');
                                        });

                                        $('#annotation-widget .comments_togle_btn').click(function () { flipPanels(true); });
                                        $(annotationWidget).find('.comments_scroll').tinyscrollbar({ sizethumb: 50 });
                                        $(annotationWidget).find('.comments_scroll_2').tinyscrollbar({ sizethumb: 50 });
                                        var annotationIconsWrapper = $(annotationWidget).find('.annotation_icons_wrapper');
                                        var annotationIconsWrapperParent = annotationIconsWrapper.parent()[0];
                                        var annotationIconsWrapperParentScrollTop;
                                        annotationsViewer.bind('onDocumentLoadComplete', function (e, data) {
                                            annotationsViewerVM.listAnnotations();
                                            annotationsViewerVM.setHandToolMode();
                                            annotationIconsWrapper.height($(annotationsViewer).find('.pages_container').height());
                                            annotationIconsWrapperParent.scrollTop = annotationIconsWrapperParentScrollTop;
                                        });
                                        annotationsViewer.bind('onDocViewScrollPositionSet', function (e, data) {
                                            annotationIconsWrapper.parent()[0].scrollTop = data.position;
                                        }.bind(this));
                                        annotationsViewer.bind('onBeforeScrollDocView onDocViewScrollPositionSet', function (e, data) {
                                            if (annotationIconsWrapperParent.scrollTop != data.position) {
                                                annotationIconsWrapperParent.scrollTop = data.position;
                                                annotationIconsWrapperParentScrollTop = data.position;
                                            }
                                        }.bind(this))

                                        function flipPanels(togglePanels) {
                                            var docViewer = $(annotationsViewer)[0];
                                            var annotationIconsPanelVisible = $(annotationWidget).find('.comments_sidebar_collapsed').is(':visible');
                                            function setIconsPanelScrollTop() {
                                                if (!annotationIconsPanelVisible)
                                                annotationIconsWrapperParent.scrollTop = docViewer.scrollTop;
                                            }

                                            function redrawLinesAndCalculateZoom() {
                                            setIconsPanelScrollTop();
                                                if (togglePanels) {
                                                    annotationsViewerVM.redrawConnectingLines(!annotationIconsPanelVisible);
                                                } else {
                                                annotationsViewerVM.resizePagesToWindowSize();
                                                    var selectableElement = annotationsViewerVM.getSelectable();
                                                    if (selectableElement != null) {
                                                        var selectable = (selectableElement.data('ui-dvselectable') || selectableElement.data('dvselectable'));
                                                        selectable.initStorage();
                                                    }

                                                annotationsViewerVM.redrawWorkingArea();
                                                }
                                            }

                                            if (togglePanels) {
                                                if (!annotationIconsPanelVisible) {
                                                    redrawLinesAndCalculateZoom();
                                                };
                                                var setIntervalId = window.setInterval(function () {
                                                    setIconsPanelScrollTop();
                                                }, 50);
                                                $(annotationWidget).find('.comments_sidebar_collapsed').toggle('slide', { direction: 'right' }, 400, function () {
                                                    clearInterval(setIntervalId);
                                                    setIconsPanelScrollTop();
                                                });
                                                $(annotationWidget).find('.comments_sidebar_expanded').toggle('slide', { direction: 'right' }, 400,

                                                function () {
                                                    if (annotationIconsPanelVisible)
                                                        redrawLinesAndCalculateZoom();
                                                    else
                                                        setIconsPanelScrollTop();
                                                        //window.setZoomWhenTogglePanel();
                                                    })

                                            } else {
                                                redrawLinesAndCalculateZoom();
                                                $(annotationWidget).find('.comments_scroll').tinyscrollbar_update('relative');
                                                $(annotationWidget).find('.comments_scroll_2').tinyscrollbar_update('relative');
                                            }
                                        }

                                        $(window).resize(function () {
                                            flipPanels(false);
                                            resizeSidebar();
                                        });
                                        resizeSidebar();

                                        function resizeSidebar() {
                                            var containerHeight = $('#annotation-widget .doc_viewer').height();
                                            $(annotationWidget).find('.comments_content').css({ 'height': (containerHeight - 152) + 'px' });
                                            $(annotationWidget).find('.comments_scroll').css({ 'height': (containerHeight - 152) + 'px' });
                                            $(annotationWidget).find('.comments_scroll .viewport').css({ 'height': (containerHeight - 172) + 'px' });
                                            $(annotationWidget).find('.comments_sidebar_collapsed').css({ 'height': (containerHeight - 50) + 'px' });
                                            $(annotationWidget).find('.comments_scroll').tinyscrollbar_update('relative');
                                            $(annotationWidget).find('.comments_scroll_2').css({ 'height': (containerHeight - 152) + 'px' });
                                            $(annotationWidget).find('.comments_scroll_2 .viewport').css({ 'height': (containerHeight - 152) + 'px' });
                                            $(annotationWidget).find('.comments_scroll_2').tinyscrollbar_update('relative');
                                        }

                                        $('html').click(function () {
                                            if ($(annotationWidget).find('.dropdown_menu_button').hasClass('active')) {
                                                $(annotationWidget).find('.dropdown_menu_button.active').next('.dropdown_menu').hide('blind', 'fast');
                                                $(annotationWidget).find('.dropdown_menu_button.active').removeClass('active');
                                            }
                                        })

                                    }

                                });
                            </script>
                            <div id='annotation-widget' class='groupdocs_viewer_wrapper grpdx' style='width:" . $width . "px;height:" . $height . "px;'>" . $content . "</div>";
            } else {
                $content = "Please change \"Use HTTP Handler\" option in edit block form";
                $txt = "<div id='annotationdotnet' style='width:" . $width . "px;height:" . $height . "px;overflow:hidden;position:relative;margin-bottom:20px;background-color:gray;border:1px solid #ccc;'>" . $content . "</div>";
            }
        }


		return $txt;
	}
}

if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/groupdocsannotation/pi1/class.tx_groupdocsannotation_pi1.php'])	{
	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/groupdocsannotation/pi1/class.tx_groupdocsannotation_pi1.php']);
}















